<?php
/**
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 *  @author Sadad Developer <developer@sadad.qa>
 *  @copyright  Copyright 2023 Sadad developer
 *  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/

require_once _PS_MODULE_DIR_ . 'sadadqa/sadadqa.php';

class SdqWebhook
{
    protected $sadadqa;
    public function __construct()
    {
    }
    public function process()
    {
        $post = $_POST;
		
        if (empty($post)) {
            return '';
        }
		
        $cartId = str_replace('ps_','',$post['ORDERID']);
        $cart = new Cart($cartId);
        $orderId = Order::getOrderByCartId($cart->id);
        if (!empty($orderId)) {
            return 'Order Already Created';
        }
        try {
			$merhcntId = trim(Configuration::get('SADADQA_KEY_ID'));
			$key_secret = trim(Configuration::get('SADADQA_KEY_SECRET'));
			
			$checksum_response = $post['checksumhash'];
			unset($post['checksumhash']);
			$sadad_id                   = $merhcntId;
			$sadad_secrete_key          = trim($key_secret);
			$data_repsonse              = array();
			$data_repsonse['postData']  = $post;
			$data_repsonse['secretKey'] = $sadad_secrete_key;
			$key                        = $sadad_secrete_key . $sadad_id;
			if ($this->verifychecksum_eFromStr(json_encode($data_repsonse), $key, $checksum_response) === "TRUE") {
			
				if ($post['transaction_status'] == 3) {
					$ordTotal = $cart->getOrderTotal(true, Cart::BOTH);
					if ($post['TXNAMOUNT'] >= $ordTotal) {
						$payment_id = $post['transaction_number'];
						$customer = new Customer($cart->id_customer);
						$extraData = array('transaction_id' => $payment_id,'transaction_number'=>$payment_id);
						$retArray = array('crt' => $cart, 'extra' => $extraData, 'secureKey' => $customer->secure_key);
						return $retArray;
					} else {
						return 'Payment failed for order due to mismatch of amounts. Please try again.';
					}
				} else {
					return 'Payment failed for Order. Please try again.';
				}
			} else {
				return 'Payment failed. Checksumhash does not match.';
			}
        } catch (Exception $e) {
            $error = $e->getMessage();
            Logger::addLog("Order creation Failed for Cart# " . $cart->id . ". Error: " . $error, 1);
            return "Order creation Failed for Cart# " . $cart->id . ". Error: " . $error;
        }
    }
	
	private function verifychecksum_eFromStr($str, $key, $checksumvalue) {
	
	$sadad_hash = $this->decrypt_e($checksumvalue, $key);
	
	$salt = substr($sadad_hash, -4);
	
	
	
	$finalString = $str . "|" . $salt;
	
	
	
	$website_hash = hash("sha256", $finalString);
	
	$website_hash .= $salt;
	
	
	
	$validFlag = "FALSE";
	
	if ($website_hash == $sadad_hash) {
	
	$validFlag = "TRUE";
	
	} else {
	
	$validFlag = "FALSE";
	
	}
	
	return $validFlag;
	
	}
	
	
	
	private function decrypt_e($crypt, $ky) {
	
	$ky = html_entity_decode($ky);
	
	$iv = "@@@@&&&&####$$$$";
	
	$data = openssl_decrypt($crypt, "AES-128-CBC", $ky, 0, $iv);
	
	return $data;
	
	}
}
