/*
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 *  @author Sadad Developer <developer@sadad.qa>
 *  @copyright  Copyright 2023 Sadad developer
 *  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/

document.addEventListener('DOMContentLoaded', function(event) {
  var conditionsForm = document.getElementById('checkout-payment-step');
  // This is a <div> and not the button.
  var submitButton = document.getElementById('payment-confirmation');
  var newSubmitButton = document.createElement('button');
  var baseClassSadad = 'btn btn-primary center-block ';
  newSubmitButton.id = 'sadadqa-pay-button';

  if (!submitButton) {
    return;
  }
  
  jQuery('img[src="./modules/sadadqa/logo.png"]').attr('id','sadadpay_logo');

  var style =
    '\
    <style>\
\ .not-shownSadad{ display: none !important;}\
    #sadadqa-pay-button.shown{\
      display: block;\
	  background-color: #8d1b3d !important;padding: 5px !important;border: 1px solid #ff6d00 !important;border-radius: 30px !important; width:30% !important;box-shadow: 3px 4px 4px rgba(0,0,0,.32) !important; line-height:20px !important;\
    }\
    #sadadqa-pay-button.not-shown{\
      display: none;\
    }\
    #sadadqa-pay-button.shown+#payment-confirmation {\
      display:none !important;\
    }\
	#sadadpay_logo{\
		width:78%;\
	}\
	@media only screen and (max-width: 766px) {\
	#sadadqa-pay-button.shown{\
		width:30% !important;\
	}\
	#sadadpay_logo{\
		width:72%;\
	}\
}\
	#sadadErrDiv{color: red;} #sadadpayDiv{ margin-top: 30px; width:100%; display:none;}\
    </style>';

		
var newDiv = document.createElement('div');	
	newDiv.id = 'sadadErrDiv';
var newDiv1 = document.createElement('div');	
	newDiv1.id = 'sadadpayDiv';	
	
	conditionsForm.insertAdjacentElement('afterend', newDiv);
	conditionsForm.insertAdjacentElement('afterend', newDiv1);
	
  newSubmitButton.innerHTML = 'Pay Now'+style;
  newSubmitButton.className = baseClassSadad + 'not-shown';
  conditionsForm.insertAdjacentElement('afterend', newSubmitButton);


  var intervalId = null;

  var contactNumber = (function() {
    for (var i in prestashop.customer.addresses) {
      var address = prestashop.customer.addresses[i];
      if (address.phone !== '') {
        return address.phone;
      }
      if (address.phone_mobile !== '') {
        return address.phone_mobile;
      }
    }
    return '';
  })();

  // Pay button gets clicked
  newSubmitButton.addEventListener('click', function(event) {
   	 var defaults = window.sadadqa_checkout_vars;
	
	  jQuery.ajax({
				type: "POST",
				url: defaults.siteUrl+'index.php?fc=module&module=sadadqa&controller=validation&isAjax=1',
				dataType: 'json',
				data: {},
				cache: false,
				success: function(response){
					
					if(response.status=='success'){
						jQuery('#sadadpayDiv').html(response.msg);
						jQuery('#sadadpayDiv').show();
						newSubmitButton.className = baseClassSadad + 'not-shown';
					} else {
						jQuery('#sadadErrDiv').html(response.msg);
					}
				}
			});
    
  });

  

  jQuery('input[name="payment-option"]').on(
    'change',
    function(e) {

      // We switch the buttons whenever a radio button (payment method)
      // or a checkbox (conditions) is changed
      if (
        this.getAttribute('data-module-name')) {
		  jQuery('#sadadpayDiv').hide();
        var selected = document.querySelector('input[data-module-name="sadadqa"]')
          .checked;
  
  

        if (selected) {
           
          newSubmitButton.className = baseClassSadad + 'shown';
			jQuery('#payment-confirmation button[type="submit"]').addClass('not-shownSadad');
        } else {
            
          newSubmitButton.className = baseClassSadad + 'not-shown';
			jQuery('#payment-confirmation button[type="submit"]').removeClass('not-shownSadad');
        }

        // This returns the first condition that is not checked
        // and works as a truthy value
        newSubmitButton.disabled = !!document.querySelector(
          'input[name^=conditions_to_approve]:not(:checked)'
        );
        

      }
    }
  );
});
